var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// packages/adapter/src/index.ts
var src_exports = {};
__export(src_exports, {
  default: () => src_default,
  kForward: () => kForward,
  kInternalMethods: () => kInternalMethods,
  kUniversalMethods: () => kUniversalMethods
});
module.exports = __toCommonJS(src_exports);

// packages/adapter/src/utils.ts
var import_koishi = require("koishi");
var import_promises = require("fs/promises");
var import_mime = __toESM(require("mime"));
var kForward = Symbol.for("adapter-forward");
var kUniversalMethods = Symbol.for("adapter-forward/universalMethods");
var kInternalMethods = Symbol.for("adapter-forward/internalMethods");
var _TimeoutError = class _TimeoutError extends Error {
  constructor(args, url) {
    super(`Timeout with request ${url}, args: ${JSON.stringify(args)}`);
    Object.defineProperties(this, {
      args: { value: args },
      url: { value: url }
    });
  }
};
__name(_TimeoutError, "TimeoutError");
var TimeoutError = _TimeoutError;
function parseElementObject(content) {
  if (typeof content === "object" && content.type && content.attrs && content.children) {
    const { type, attrs, children } = content;
    return (0, import_koishi.h)(type, attrs, children.map(parseElementObject));
  } else
    throw new TypeError(`Invalid element object ${content}`);
}
__name(parseElementObject, "parseElementObject");
function parseElementObjects(content) {
  return content.map(parseElementObject);
}
__name(parseElementObjects, "parseElementObjects");
async function prepareElement(bot, element) {
  var _a2, _b;
  if ((_b = (_a2 = element.attrs) == null ? void 0 : _a2.url) == null ? void 0 : _b.startsWith("file://")) {
    const url = new URL(element.attrs.url);
    const mimetype = import_mime.default.getType(url.pathname);
    const buffer = Buffer.from(await (0, import_promises.readFile)(url));
    const base64 = (0, import_koishi.arrayBufferToBase64)(buffer);
    return (0, import_koishi.h)(element.type, {
      ...element.attrs,
      url: element.attrs.url = `data:${mimetype};base64,${base64}`
    }, await prepareElements(bot, element.children));
  } else {
    return (0, import_koishi.h)(element.type, element.attrs, await prepareElements(bot, element.children));
  }
}
__name(prepareElement, "prepareElement");
async function prepareElements(bot, elements) {
  return Promise.all(elements.map((el) => prepareElement(bot, el)));
}
__name(prepareElements, "prepareElements");
async function prepareUniversalMethods(bot, action, args) {
  switch (action) {
    case "sendMessage": {
      args[1] = (await prepareElements(bot, import_koishi.h.normalize(args[1]))).join("");
      break;
    }
    case "sendPrivateMessage": {
      args[1] = (await prepareElements(bot, import_koishi.h.normalize(args[1]))).join("");
      break;
    }
  }
  return args;
}
__name(prepareUniversalMethods, "prepareUniversalMethods");

// packages/adapter/src/host.ts
var import_koishi4 = require("koishi");

// packages/adapter/src/ws.ts
var import_koishi2 = require("koishi");
var import_cosmokit = require("cosmokit");
var logger = new import_koishi2.Logger("forward");
var _WsClient = class _WsClient extends import_koishi2.Adapter.WsClient {
  constructor() {
    super(...arguments);
    this.accept = accept;
  }
  async prepare(bot) {
    const http = this.ctx.http.extend(bot.config);
    return http.ws(bot.config.endpoint);
  }
};
__name(_WsClient, "WsClient");
var WsClient = _WsClient;
((WsClient2) => {
  WsClient2.Config = import_koishi2.Schema.intersect([
    import_koishi2.Schema.object({
      protocol: import_koishi2.Schema.const("ws").required(false),
      responseTimeout: import_koishi2.Schema.natural().role("time").default(import_koishi2.Time.minute).description("等待响应的时间 (单位为毫秒)。")
    }).description("连接设置"),
    import_koishi2.Quester.createConfig("ws://127.0.0.1:5140/forward"),
    import_koishi2.Adapter.WsClient.Config
  ]);
})(WsClient || (WsClient = {}));
var _WsServer = class _WsServer extends import_koishi2.Adapter.Server {
  constructor(ctx, bot) {
    super();
    const { path = "/forward" } = bot.config;
    this.wsServer = ctx.router.ws(path, (socket, { headers }) => {
      logger.debug("connected");
      accept(bot, socket);
    });
    ctx.on("dispose", () => {
      logger.debug("ws server closing");
      this.wsServer.close();
    });
  }
  async stop(bot) {
    var _a2;
    (_a2 = bot.socket) == null ? void 0 : _a2.close();
    bot.socket = null;
  }
};
__name(_WsServer, "WsServer");
var WsServer = _WsServer;
((WsServer2) => {
  WsServer2.Config = import_koishi2.Schema.object({
    protocol: import_koishi2.Schema.const("ws-reverse").required(true),
    path: import_koishi2.Schema.string().description("服务器监听的路径。").default("/forward"),
    responseTimeout: import_koishi2.Schema.natural().role("time").default(import_koishi2.Time.minute).description("等待响应的时间 (单位为毫秒)。")
  }).description("连接设置");
})(WsServer || (WsServer = {}));
var counter = 0;
var listeners = {};
function accept(client, socket) {
  socket || (socket = client.socket);
  socket.addEventListener("message", async ({ data }) => {
    let packet;
    try {
      packet = JSON.parse(data.toString());
    } catch (error) {
      return logger.warn("cannot parse message", data);
    }
    logger.debug("receive %o", packet);
    await processPacket(client, socket, packet);
  });
  const connectPacket = { type: "meta::connect", payload: { token: client.config.token } };
  socket.send(JSON.stringify(connectPacket));
}
__name(accept, "accept");
async function processPacket(client, socket, packet) {
  const { type, payload, sid, echo } = packet;
  if (echo in listeners) {
    const [resolve, reject] = listeners[echo];
    if (type === "meta::error") {
      reject(payload);
    } else {
      resolve(payload);
    }
    delete listeners[echo];
    return;
  }
  let bot = client.getBot(sid);
  switch (type) {
    case "meta::connect": {
      break;
    }
    case "meta::event": {
      if (!bot)
        return;
      const { session: sessionPayload, payload: internalPayload } = payload;
      const session = bot.session();
      (0, import_cosmokit.defineProperty)(session, kForward, true);
      Object.assign(session, sessionPayload);
      (0, import_cosmokit.defineProperty)(session, bot.platform, Object.create(bot.internal));
      Object.assign(session[bot.platform], internalPayload);
      session.elements = parseElementObjects(session.elements);
      session.content = session.elements.join("");
      bot.dispatch(session);
      break;
    }
    case "meta::status": {
      if (!bot) {
        bot = await client.addBot(sid, {
          universalMethods: payload.universalMethods,
          internalMethods: payload.internalMethods
        });
        logger.info("Connect to bot: %s", bot.sid);
        socket.addEventListener("close", () => client.removeBot(bot));
        bot.internal._send = (type2, payload2, rest = {}, socketArg) => {
          socketArg || (socketArg = socket);
          if (!socketArg)
            return;
          const packet2 = { type: type2, payload: payload2, sid: bot.sid, ...rest };
          logger.debug("send ws %o", packet2);
          return new Promise((resolve, reject) => {
            socket.send(JSON.stringify(packet2), (error) => {
              if (error)
                reject(error);
            });
            return resolve();
          });
        };
        bot.internal._call = (type2, payload2, rest = {}, socketArg) => {
          socketArg || (socketArg = socket);
          const packet2 = { type: type2, payload: payload2, echo: ++counter, sid: bot.sid, ...rest };
          logger.debug("send ws %o", packet2);
          return new Promise((resolve, reject) => {
            listeners[packet2.echo] = [resolve, reject];
            setTimeout(() => {
              delete listeners[packet2.echo];
              reject(new TimeoutError(payload2, type2));
            }, client.config.responseTimeout);
            socket.send(JSON.stringify(packet2), (error) => {
              if (error)
                reject(error);
            });
          });
        };
      } else {
        if (payload.universalMethods) {
          bot[kUniversalMethods] = payload.universalMethods;
          bot._updateUniversalMethods();
          logger.debug("universalMethods detected", bot[kUniversalMethods]);
        }
        if (payload.internalMethods) {
          bot[kInternalMethods] = payload.internalMethods;
          logger.debug("internalMethods detected", bot[kInternalMethods]);
        }
      }
      if (payload.status && payload.status !== bot.status) {
        switch (payload.status) {
          case "online":
            bot.status = "online";
            await bot.initialize();
            break;
          case "unavailable":
            client.removeBot(bot);
            break;
          default:
            bot.status = payload.status;
        }
      }
      if (bot && payload.user) {
        Object.assign(bot, payload.user);
      }
    }
  }
}
__name(processPacket, "processPacket");

// packages/adapter/src/bot.ts
var import_koishi3 = require("koishi");
var import_adapter_forward = require("@hieuzest/adapter-forward");
var logger2 = new import_koishi3.Logger("forward");
var _a;
var _ForwardBot = class _ForwardBot extends import_koishi3.Bot {
  constructor(ctx, config) {
    super(ctx, config);
    this[_a] = true;
    _ForwardBot.prototype.platform = config.platform;
    this.selfId = config.selfId;
    this[kUniversalMethods] = config.universalMethods;
    this[kInternalMethods] = config.internalMethods;
    this.internal = new Proxy({}, {
      set(target, p, newValue, receiver) {
        return Reflect.set(target, p, newValue, receiver);
      },
      get(target, p, receiver) {
        var _a2;
        if (Reflect.has(target, p))
          return Reflect.get(target, p, receiver);
        if (typeof p === "symbol")
          return null;
        if (!Reflect.has(target, "_request")) {
          logger2.error("Bot not connected");
          return;
        }
        if ((_a2 = this[kInternalMethods]) == null ? void 0 : _a2.includes(p)) {
          return (...args) => target._call("action::internal", {
            action: p,
            args
          });
        }
      }
    });
    this._updateUniversalMethods();
    if (config.callback) {
      config.callback(this);
      delete config.callback;
    }
  }
  async initialize() {
    if (!this.getSelf)
      return;
    await this.getSelf().then((data) => Object.assign(this, data));
  }
  _updateUniversalMethods() {
    var _a2, _b;
    for (const method of import_adapter_forward.universalMethods) {
      try {
        if (!import_adapter_forward.predefinedUniversalMethods.includes(method) && !!this[method] === !!(!this[kUniversalMethods] || ((_a2 = this[kUniversalMethods]) == null ? void 0 : _a2.includes(method))))
          continue;
        if (!this[kUniversalMethods] || ((_b = this[kUniversalMethods]) == null ? void 0 : _b.includes(method))) {
          this[method] = async (...args) => {
            if (!this.internal._send) {
              logger2.error("Bot not connected");
              return;
            }
            return await this.internal._call("action::bot", {
              action: method,
              args: await prepareUniversalMethods(this, method, args)
            });
          };
        } else {
          delete this[method];
        }
      } catch (e) {
        logger2.warn("Hooking %s %s failed", this.sid, method);
      }
    }
  }
};
_a = kForward;
__name(_ForwardBot, "ForwardBot");
var ForwardBot = _ForwardBot;
ForwardBot.prototype[kForward] = true;

// packages/adapter/src/host.ts
var _ForwardHost = class _ForwardHost extends import_koishi4.Bot {
  constructor(ctx, config) {
    super(ctx, config);
    this.platform = "forward";
    this.selfId = "host";
    this.hidden = true;
    if (config.protocol === "ws") {
      ctx.plugin(WsClient, this);
    } else if (config.protocol === "ws-reverse") {
      ctx.plugin(WsServer, this);
    }
  }
  validateSid(sid) {
    return !this.config.sids.length || this.config.sids.includes(sid);
  }
  getBots() {
    return this.ctx.bots.filter((bot) => bot[kForward] && this.validateSid(bot.sid));
  }
  getBot(sid) {
    return this.ctx.bots.find((bot) => bot[kForward] && bot.sid === sid);
  }
  async addBot(sid, rest) {
    const [platform, selfId] = parsePlatform(sid);
    return new Promise((resolve) => {
      this.ctx.plugin(ForwardBot, { platform, selfId, callback: resolve, ...rest });
    });
  }
  removeBot(bot) {
    return bot.ctx.scope.dispose();
  }
};
__name(_ForwardHost, "ForwardHost");
var ForwardHost = _ForwardHost;
((ForwardHost2) => {
  ForwardHost2.BaseConfig = import_koishi4.Schema.object({
    sids: import_koishi4.Schema.array(String).default([]),
    token: import_koishi4.Schema.string().role("secret"),
    protocol: import_koishi4.Schema.union(["ws", "ws-reverse"]).default("ws")
  });
  ForwardHost2.Config = import_koishi4.Schema.intersect([
    ForwardHost2.BaseConfig,
    import_koishi4.Schema.union([
      WsServer.Config,
      WsClient.Config
    ])
  ]);
})(ForwardHost || (ForwardHost = {}));
function parsePlatform(sid) {
  let platform, selfId;
  const index = sid.indexOf(":");
  platform = sid.slice(0, index);
  selfId = sid.slice(index + 1);
  return [platform, selfId];
}
__name(parsePlatform, "parsePlatform");

// packages/adapter/src/index.ts
var src_default = ForwardHost;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  kForward,
  kInternalMethods,
  kUniversalMethods
});
//# sourceMappingURL=index.js.map
